#include <iostream>
#include <set>
#include <algorithm>

#define F first
#define S second

using namespace std;
using ll = long long;
using pii= pair<int, int>;

const int INF = 1e9;

set<int> hor, vert;
set<pii> people;
int w, h, c, p, x, y, ans = INF,  ql, qr;

int main()
{
    cin >> w >> h >> c >> p;
    vert.insert(0); hor.insert(0);
    vert.insert(w);
    while(p--) {
        char s[9]; int t; cin >> s >> t;
        if(s[0] == 'v') vert.insert(t);
        else hor.insert(t);
    }
    while(c--) {
        int u, v; cin >> u >> v;
        people.insert({u, v});
    }
    cin >> y >> x;

    if(hor.count(y-1) != 0) ans = 0;

    int lc = 0, lr = INF;
    for(int kek : vert) {
        if(kek <= x && kek > lc) lc = kek;
        if(kek >= x && kek < lr) lr = kek;
    }
    for(pii p : people) {
        if(p.F != y) continue;
        if(p.S <= x && p.S > lc) ++ql;
        if(p.S >= x && p.S < lr) ++qr;
    }

    cout << min(ans, min(ql, qr));
}
