#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector<ll> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        a[i] += a[i - 1];
    }

    int m;
    cin >> m;

    vector<ll> p(m);
    vector<pair<int, int>> st(m), en(m);
    vector<pair<int, int>> o(m);

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--; r--;

        st[i].first = l;
        en[i].first = r;

        int x = a[r] - a[l - 1];
        st[i].second = i;
        en[i].second = i;
        p[i] = x;

        o[i] = {l, r};
    }
    sort(st.begin(), st.end());
    sort(en.begin(), en.end());

    for (int i = m - 2; i >= 0; i--) {
        ll x = p[st[i].second];
        ll xx = p[st[i + 1].second];
        if (xx > x) st[i].second = st[i + 1].second;
    }

    for (int i = 1; i < m; i++) {
        ll x = p[en[i].second];
        ll xx = p[en[i - 1].second];
        if (xx > x) en[i].second = en[i - 1].second;
    }

    ll ans = (ll)-2e18;
    pair<int, int> anss = {-2, -2};
    for (int i = 0; i < o.size(); i++) {
        auto e = o[i];
        int l = e.first, r = e.second;
        ll x = a[r] - a[l - 1];

        int lll = 0, rr = st.size();
        while (rr - lll > 1) {
            int mm = (lll + rr) / 2;

            if (st[mm].first > r) rr = mm;
            else lll = mm;
        }
        if (rr != st.size()) {
            int xx = st[rr].second;
            if (x + p[xx] > ans) {
                ans = x + p[xx];
                anss = {i, xx};
            }
        }

        lll = -1, rr = en.size();
        while (rr - lll > 1) {
            int mm = (lll + rr) / 2;

            if (en[mm].first < l) lll = mm;
            else rr = mm;
        }
        if (lll != -1) {
            int xx = en[lll].second;
            if (x + p[xx] > ans) {
                ans = x + p[xx];
                anss = {i, xx};
            }
        }
    }

    cout << anss.first + 1 << ' ' << anss.second + 1;

    return 0;
}
