#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n;
ll last_sum;

map<int, ll> mp;

void answer(int a, int b, int c) {
    cout << "! " << a << ' ' << b << ' ' << c << endl;
}

ll ask(int x) {
    if (mp[x]) return mp[x];
    cout << "? " << x << endl;
    ll ans;
    cin >> ans;
    mp[x] = ans;
    return ans;
}

ll get_sum(ll n) {
    return n * (n + 1) / 2;
}

int fn(int L) {
    int l = L, r = n;
    ll S = (L - 1 ? ask(L - 1) : 0);
    while (l < r) {
        int mid = (l + r) / 2;
        ll sum = ask(mid) - S;
        ll d = get_sum(mid) - get_sum(L - 1);
        if (d != sum)
            r = min(1ll * mid, d - sum);
        else
            l = mid + 1;
    }
    return l;
}

void solve() {
    cin >> n;
    ll d_sum = get_sum(n) - ask(n);
    n = min(1ll * n, d_sum);
    int a = fn(1);
    int b = fn(a + 1);
    int c = d_sum - a - b;
    answer(a, b, c);
}

int main() {
    //freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
