#include <iostream>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

const int N = 2e5+7;
const int M = 2e5+7;
const ll LINF = 1e17;

ll prefix[N], res = -LINF;
int n, m, sa=-1, sb=-1;

struct Shava {
    int l, r, id;
    ll b;
} d[M], d2[M];

int main()
{
    cin >> n;
    for(int i = 0; i < n; ++i) {
        cin >> prefix[i+1];
        prefix[i+1] += prefix[i];
    }

    cin >> m;

    multiset<pair<ll, int>> cnt;
    for(int i = 0; i < m; ++i) {
        cin >> d[i].l >> d[i].r;
        d[i].b = prefix[d[i].r] - prefix[d[i].l-1];
        d[i].id = i;
        cnt.insert({d[i].b, i});
    }

    sort(d, d+m, [](Shava& a, Shava& b) {
         return a.r < b.r;
    });
    copy(d, d+m, d2);
    sort(d2, d2+m, [](Shava& a, Shava& b) {
         return a.l < b.l;
    });

    for(int i = 0, j = 0; i < m; ++i) {
        ll cost = d[i].b;
        while(j < m && d2[j].l <= d[i].r)
            cnt.erase({d2[j].b, d2[j].id}), ++j;
        if(!cnt.empty()) {
            cost += cnt.rbegin()->first;
            if(res < cost) {
                res = cost;
                sa = 1+d[i].id;
                sb = 1+cnt.rbegin()->second;
            }
        }
    }

    cout << sa << ' ' << sb << endl;
}
