#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int max_n = 500500 * 3;
int ta[max_n << 2], tb[max_n << 2], d = 1;

void adda(int i, int x)
{
    ta[i + d] = x;
    for(i = (i + d) >> 1; i >= 1; i >>= 1)
    {
        ta[i] = min(ta[i << 1], ta[i << 1 | 1]);
    }
}

void addb(int i, int x)
{
    tb[i + d] = x;
    for(i = (i + d) >> 1; i >= 1; i >>= 1)
    {
        tb[i] = min(tb[i << 1], tb[i << 1 | 1]);
    }
}

int geta(int l, int r)
{
    int ans = INT_MAX;
    for(l += d, r += d; l <= r; ++l >>= 1, --r >>= 1)
    {
        if(l & 1) ans = min(ans, ta[l]);
        if(~r & 1) ans = min(ans, ta[r]);
    }
    return ans;
}

int getb(int l, int r)
{
    int ans = INT_MAX;
    for(l += d, r += d; l <= r; ++l >>= 1, --r >>= 1)
    {
        if(l & 1) ans = min(ans, tb[l]);
        if(~r & 1) ans = min(ans, tb[r]);
    }
    return ans;
}

int main()
{
    while(d < max_n) d <<= 1;
    for(int i = 0; i < max_n; i++)
    {
        adda(i, INT_MAX);
        addb(i, INT_MAX);
    }
    int n, k;
    cin >> n >> k;
    vector<int> a, b, v;
    for(int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        v.push_back(x);
    }
    for(int i = 0; i < 2 * n; i++)
    {
        v.push_back(v[i]);
    }
    for(int i = 0; i < 3 * n; i++)
    {
        if(i & 1) b.push_back(v[i]);
        else a.push_back(v[i]);
    }
    for(int i = 0; i < a.size(); i++) adda(i, a[i]);
    for(int i = 0; i < b.size(); i++) addb(i, b[i]);
    for(int i = n; i < 2 * n; i++)
    {
        if(k & 1)
        {
            if(i & 1)
            {
                int j = i / 2;
                int l = max(0, j - k / 2);
                int r = min((int)a.size() - 1, j + k / 2 + 1);
                cout << geta(l, r) << " ";
            }
            else
            {
                int j = i / 2;
                int l = max(0, j - k / 2 - 1);
                int r = min((int)b.size() - 1, j + k / 2 + 1 - 1);
                cout << getb(l, r) << " ";
            }
        }
        else
        {
            if(i & 1)
            {
                int j = i / 2;
                int l = max(0, j - k / 2);
                int r = min((int)b.size() - 1, j + k / 2);
                //cout << l << " " << r << endl;
                cout << getb(l, r) << " ";
            }
            else
            {
                int j = i / 2;
                int l = max(0, j - k / 2);
                int r = min((int)a.size() - 1, j + k / 2);
                //cout << l << " " << r << endl;
                cout << geta(l, r) << " ";
            }
        }
    }
}
