#include <iostream>
#include <vector>
#include <map>

using namespace std;

long long nod(long long a,long long b){
    if(a<b) swap(a,b);
    while(b!=0){
        a=a%b;
        swap(a,b);
    }
    return a;
}

long long nok(long long a,long long b){
    return a/nod(a,b)*b;
}

int main()
{
    int w,h,c,p; cin>>w>>h>>c>>p;
    vector<int> hor,vert;
    hor.push_back(0);
    vert.push_back(0),vert.push_back(w+1);
    string s; int a;
    for(int i=0;i<p;++i){
        cin>>s>>a;
        if(s=="vert") vert.push_back(a);
        else hor.push_back(a);
    }
    map<int,vector<int> >hh;
    map<int,vector<int> >vv;
    pair<int,int> l;
    for(int i=0;i<c;++i){
        cin>>l.first>>l.second;
        hh[l.first].push_back(l.second);
        vv[l.second].push_back(l.first);
    }
    pair<int,int> v; cin>>v.first>>v.second;
    int vl=0,vr=w+1,hd=0;
    for(int i=0;i<vert.size();++i){
        if(vert[i]<v.second&&vert[i]>vl) vl=vert[i];
        if(vert[i]>v.second&&vert[i]<vr) vr=vert[i];
    }
    for(int i=0;i<hor.size();++i)
        if(hor[i]>hd&&hor[i]<v.first) hd=hor[i];
    if(hd==v.first-1){
        cout<<0;
        return 0;
    }
    int a1=0,a2=0;
    for(int i=0;i<hh[v.first].size();++i){
        if(hh[v.first][i]>vl&&hh[v.first][i]<v.second) ++a1;
        if(hh[v.first][i]<vr&&hh[v.first][i]>v.second) ++a2;

    }
    cout<<min(a1,a2);
    return 0;
}
