#include <bits/stdc++.h>

using namespace std;

string st;

map<string, vector<int> > mp;
map<string, vector<pair<string, int> > > G;

vector<string> Q;

bool dfs(string v) {
    if (v == "throw") {
        cout << v << endl;
        return true;
    }
    auto& q = G[v];
    for (auto& to: q)
        if (to.second == 0) {
            cout << to.first << "()" << endl;
            Q.push_back(to.first);
        } else
            if (dfs(to.first)) return true;
    int n = q.size();
    for (int i = n - 1; i >= 0; --i)
        if (q[i].second == 0) {
            cout << '~' << Q.back() << "()" << endl;
            Q.pop_back();
        }
    return false;
}

void solve() {
    getline(cin, st);
    string cur_fn;
    while (st != "") {
        if (st == "throw")
            G[cur_fn].push_back({st, 1});
        else if (st.back() == '{') {
            string name;
            int n = st.size();
            for (int i = 5; i < n; ++i)
                if (st[i] == '(')
                    break;
                else
                    name += st[i];
            cur_fn = name;
        } else if (st.front() != '}') {
            if (st.back() == ')') {
                string name;
                int n = st.size();
                for (int i = 0; i < n; ++i)
                    if (st[i] == '(')
                        break;
                    else
                        name += st[i];
                G[cur_fn].push_back({name, 1});
            } else {
                string tp, name;
                int n = st.size();
                int k = 0;
                for (int i = 0; i < n; ++i)
                    if (st[i] == ' ') {
                        k = i + 1;
                        break;
                    } else
                        tp += st[i];
                for (int i = 5; i < n; ++i)
                    if (st[i] == ' ')
                        break;
                    else
                        name += st[i];
                G[cur_fn].push_back({tp, 0});
            }
        }
        getline(cin, st);
    }
    dfs("main");
    while (!Q.empty()) {
        cout << '~' << Q.back() << "()" << endl;
        Q.pop_back();
    }
}

int main() {
    //freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
