#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n;
ll last_sum;

map<int, ll> mp;

void answer(int a, int b, int c) {
    cout << "! " << a << ' ' << b << ' ' << c << endl;
}

ll ask(int x) {
    if (mp[x]) return mp[x];
    cout << "? " << x << endl;
    ll ans;
    cin >> ans;
    mp[x] = ans;
    return ans;
}

ll get_sum(ll n) {
    return n * (n + 1) / 2;
}

int fn(int L) {
    int l = L, r = n;
    ll S = last_sum;
    while (l < r) {
        int mid = (l + r) / 2;
        last_sum = ask(mid);
        ll sum = last_sum - S;
        if (get_sum(mid) - get_sum(L - 1) != sum)
            r = mid;
        else
            l = mid + 1;
    }
    return l;
}

void solve() {
    cin >> n;
    int a = fn(1);
    int b = fn(a + 1);
    int c = fn(b + 1);
    answer(a, b, c);
}

int main() {
    //freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
