#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 2e5 + 5;
const long long INF = 2e18 + 18;

struct node {
    int num, l, r;
    node(int num, int l, int r) : num(num), l(l), r(r) { }
    bool operator <(const node& other) {
        return r < other.r;
    }
};

int n, m;
ll pref[N];
pair<ll, int> dp[N];
pair<ll, pair<int, int> > ans;
vector<node> Q[N];

ll get_sum(int l, int r) {
    return pref[r] - pref[l - 1];
}

void solve() {
    scanf("%d", &n);
    for (int i = 1; i <= n; ++i) {
        int x;
        scanf("%d", &x);
        pref[i] = pref[i - 1] + x;
    }
    scanf("%d", &m);
    for (int i = 0; i <= n; ++i)
        dp[i] = {-INF, -INF};
    for (int i = 0; i < m; ++i) {
        int l, r;
        scanf("%d%d", &l, &r);
        Q[r].push_back(node(i + 1, l, r));
    }
    ans = {-INF, {-1, -1}};
    for (int i = 1; i <= n; ++i) {
        dp[i] = dp[i - 1];
        for (auto& it: Q[i]) {
            dp[i] = max(dp[i], make_pair(get_sum(it.l, it.r), it.num));
            if (dp[it.l - 1].first != -INF) {
                pair<ll, pair<int, int> > tmp = {dp[it.l - 1].first + get_sum(it.l, it.r), {dp[it.l - 1].second, it.num}};
                ans = max(ans, tmp);
            }
        }
    }
    printf("%d %d", ans.second.first, ans.second.second);
}

int main() {
    //freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
